Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class ComputedExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

Direct Known Subclasses:
  Assignation, AxisExpression, BinaryExpression, CastAsQName, ContextItemExpression, ErrorExpression, FilterExpression, FunctionCall, IfExpression, Instruction, IntegerRangeTest, IsLastExpression, NumberInstruction, PathExpression, PositionRange, SequentialCopy, SimpleContentConstructor, SimpleExpression, SimpleMappingExpression, SingleNodeExpression, SliceExpression, SortExpression, SuppliedParameterReference, TailExpression, TupleExpression, TupleSorter, UnaryExpression, VariableReference

public abstract class ComputedExpression
extends java.lang.Object
implements java.io.Serializable, Expression, InstructionInfoProvider, Container

This class is an abstract superclass for different kinds of expression. This includes XSLT instructions, which are treated just like XPath expressions. Every expression is either a constant Value, or a ComputedExpression.

There are three principal methods for evaluating an expression: iterate(), which an iterator over the result of the expression as a sequence; evaluateItem(), which returns an object that is an instance of net.sf.saxon.om.Item; and process(), which pushes the results of the expression to a Receiver. All three methods take an XPathContext object to supply the evaluation context; for an expression that is a Value, this argument is ignored and may be null. This root class provides an implementation of iterate() in terms of evaluateItem() that works only for singleton expressions, and an implementation of evaluateItem() in terms of iterate() that works only for non-singleton expressions. Subclasses of expression must therefore provide either iterate() or evaluateItem() or process(): they do not have to provide all three.

Note that the methods that take an XPathContext argument are run-time methods. The methods without such an argument are compile-time methods. Run-time methods must not modify the state of the Expression object.

See Also:
  Serialized Form

Field Summary
`protected int` | `locationId`
`protected int` | `staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ComputedExpression()`

Method Summary
`void` | `adoptChildExpression(Expression child)`
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`protected abstract int` | `computeCardinality()`
`int` | `computeDependencies()` Compute the dependencies of an expression, as the union of the dependencies of its subexpressions.
`int` | `computeSpecialProperties()`
`void` | `computeStaticProperties()` Compute the static properties.
`Expression` | `doPromotion(Expression subexpression, PromotionOffer offer)` Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree
`protected void` | `dynamicError(java.lang.String message, java.lang.String code, XPathContext context)` Method used in subclasses to signal a dynamic error
`protected void` | `dynamicError(java.lang.String message, XPathContext context)` Method used in subclasses to signal a dynamic error
`boolean` | `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the expression.
`java.lang.String` | `evaluateAsString(XPathContext context)` Evaluate an expression as a String.
`Item` | `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
`int` | `getCardinality()` Determine the static cardinality of the expression.
`int` | `getColumnNumber()` Get the column number of the expression
`protected int` | `getConstructType()` Get the type of this expression for use in tracing and diagnostics
`int` | `getDependencies()` Determine which aspects of the context the expression depends on.
`Executable` | `getExecutable()` Get the executable containing this expression
`int` | `getHostLanguage()` Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
`int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`InstructionInfo` | `getInstructionInfo()` Get InstructionInfo for this expression
`int` | `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
`int` | `getLineNumber()` Get the line number of the expression
`int` | `getLocationId()` Get the location ID of the expression
`LocationProvider` | `getLocationProvider()` Get the LocationProvider allowing location identifiers to be resolved.
`Container` | `getParentExpression()` Get the expression that immediately contains this expression.
`java.lang.String` | `getPublicId()` Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)
`int[]` | `getSlotsUsed()` Get the local variables (identified by their slot numbers) on which this expression depends.
`int` | `getSpecialProperties()` Get the static properties of this expression (other than its type).
`java.lang.String` | `getSystemId()` Get the systemId of the module containing the expression
`boolean` | `hasBadParentPointer()` Diagnostic method: search the tree for an expression whose parent expression is incorrectly set
`SequenceIterator` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
`java.util.Iterator` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`boolean` | `markTailFunctionCalls()` Mark tail-recursive calls on stylesheet functions.
`void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
`Expression` | `promote(PromotionOffer offer)` Offer promotion for this subexpression.
`void` | `resetStaticProperties()` Reset the static properties.
`void` | `setLocationId(int id)` Set the location ID on an expression.
`void` | `setParentExpression(Container parent)`
`Expression` | `simplify(StaticContext env)` Simplify an expression.
`void` | `suppressValidation(int validationMode)` Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation.
`protected void` | `typeError(java.lang.String message, java.lang.String errorCode, XPathContext context)` Method used in subclasses to signal a runtime type error
`protected void` | `typeError(java.lang.String message, XPathContext context)` Method used in subclasses to signal a runtime type error

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.expr.Expression
`display, getItemType, optimize, typeCheck`

Field Detail

### staticProperties

    protected int staticProperties

### locationId

    protected int locationId

Constructor Detail

### ComputedExpression

    public ComputedExpression()

Method Detail

### getParentExpression

    public Container getParentExpression()

  Get the expression that immediately contains this expression. This method returns null for an outermost expression; it also return null in the case of literal values. For an XPath expression occurring within an XSLT stylesheet, this method returns the XSLT instruction containing the XPath expression.

  Specified by:
    `getParentExpression` in interface `Expression`
  Returns:
    the expression that contains this expression, if known; return null if there is no containing expression or if the containing expression is unknown.

### setParentExpression

    public void setParentExpression(Container parent)

### adoptChildExpression

    public void adoptChildExpression(Expression child)

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is prefered.

  Specified by:
    `getImplementationMethod` in interface `Expression`

### setLocationId

    public void setLocationId(int id)

  Set the location ID on an expression.

### getLocationId

    public final int getLocationId()

  Get the location ID of the expression

### getLineNumber

    public int getLineNumber()

  Get the line number of the expression

  Specified by:
    `getLineNumber` in interface `javax.xml.transform.SourceLocator`

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the expression

  Specified by:
    `getColumnNumber` in interface `javax.xml.transform.SourceLocator`

### getSystemId

    public java.lang.String getSystemId()

  Get the systemId of the module containing the expression

  Specified by:
    `getSystemId` in interface `javax.xml.transform.SourceLocator`

### getPublicId

    public final java.lang.String getPublicId()

  Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)

  Specified by:
    `getPublicId` in interface `javax.xml.transform.SourceLocator`

### getExecutable

    public Executable getExecutable()

  Get the executable containing this expression

  Specified by:
    `getExecutable` in interface `Container`

### getLocationProvider

    public LocationProvider getLocationProvider()

  Get the LocationProvider allowing location identifiers to be resolved.

  Specified by:
    `getLocationProvider` in interface `Container`

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in interface `Expression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Offer promotion for this subexpression. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Specified by:
    `promote` in interface `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### doPromotion

    public final Expression doPromotion(Expression subexpression,
                                        PromotionOffer offer)
                                 throws XPathException

  Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree

  Throws:
    `XPathException`

### getSpecialProperties

    public final int getSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Specified by:
    `getSpecialProperties` in interface `Expression`
  Returns:
    a set of flags indicating static properties of this expression

### computeStaticProperties

    public final void computeStaticProperties()

  Compute the static properties. This should only be done once for each expression.

### resetStaticProperties

    public final void resetStaticProperties()

  Reset the static properties. This should be done whenever the expression is changed in a way that might affect the properties. It causes the properties to be recomputed next time they are needed.

### computeCardinality

    protected abstract int computeCardinality()

### computeSpecialProperties

    public int computeSpecialProperties()

### getCardinality

    public int getCardinality()

  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Specified by:
    `getCardinality` in interface `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### getDependencies

    public int getDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Specified by:
    `getDependencies` in interface `Expression`
  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### computeDependencies

    public int computeDependencies()

  Compute the dependencies of an expression, as the union of the dependencies of its subexpressions. (This is overridden for path expressions and filter expressions, where the dependencies of a subexpression are not all propogated). This method should be called only once, to compute the dependencies; after that, getDependencies should be used.

  Returns:
    the depencies, as a bit-mask

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".

  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### suppressValidation

    public void suppressValidation(int validationMode)

  Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation. The default implementation does nothing.

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Parameters:
    `parentType` - The schema type
    `env` - the static context
    `whole` - true if this expression is expected to make the whole content of the type, false if it is expected to make up only a part
  Throws:
    `XPathException` - if the expression doesn't match the required content type

### markTailFunctionCalls

    public boolean markTailFunctionCalls()

  Mark tail-recursive calls on stylesheet functions. For most expressions, this does nothing.

  Returns:
    true if a tail recursive call was found and if this call accounts for the whole of the value.

### getSlotsUsed

    public int[] getSlotsUsed()

  Get the local variables (identified by their slot numbers) on which this expression depends. Should only be called if the caller has established that there is a dependency on local variables.

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.

  Specified by:
    `evaluateItem` in interface `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateAsString

    public java.lang.String evaluateAsString(XPathContext context)
                                      throws XPathException

  Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.

  Specified by:
    `evaluateAsString` in interface `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression
    `java.lang.ClassCastException` - if the result type of the expression is not xs:string?

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.

  Specified by:
    `iterate` in interface `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.

  Specified by:
    `effectiveBooleanValue` in interface `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Specified by:
    `process` in interface `Expression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### dynamicError

    protected void dynamicError(java.lang.String message,
                                XPathContext context)
                         throws DynamicError

  Method used in subclasses to signal a dynamic error

  Throws:
    `DynamicError`

### dynamicError

    protected void dynamicError(java.lang.String message,
                                java.lang.String code,
                                XPathContext context)
                         throws DynamicError

  Method used in subclasses to signal a dynamic error

  Throws:
    `DynamicError`

### typeError

    protected void typeError(java.lang.String message,
                             XPathContext context)
                      throws DynamicError

  Method used in subclasses to signal a runtime type error

  Throws:
    `DynamicError`

### typeError

    protected void typeError(java.lang.String message,
                             java.lang.String errorCode,
                             XPathContext context)
                      throws DynamicError

  Method used in subclasses to signal a runtime type error

  Throws:
    `DynamicError`

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Get InstructionInfo for this expression

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`

### getConstructType

    protected int getConstructType()

  Get the type of this expression for use in tracing and diagnostics

  Returns:
    the type of expression, as enumerated in class `Location`

### hasBadParentPointer

    public boolean hasBadParentPointer()

  Diagnostic method: search the tree for an expression whose parent expression is incorrectly set

### getHostLanguage

    public int getHostLanguage()

  Get the host language (XSLT, XQuery, XPath) used to implement the code in this container

  Specified by:
    `getHostLanguage` in interface `Container`
  Returns:
    typically `Configuration.XSLT` or `Configuration.XQUERY`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD